# Passes

This document describes the available MLIR passes and their contracts.

[TOC]

## General Transformation Passes

[include "GeneralPasses.md"]

## Bufferization Passes

[include "BufferizationPasses.md"]

## Conversion Passes

[include "ConversionPasses.md"]

## `async` Dialect Passes

[include "AsyncPasses.md"]

## `affine` Dialect Passes

[include "AffinePasses.md"]

## `arith` Dialect Passes

[include "ArithPasses.md"]

## `func` Dialect Passes

[include "FuncPasses.md"]

## `gpu` Dialect Passes

[include "GPUPasses.md"]

## `linalg` Dialect Passes

[include "LinalgPasses.md"]

## `llvm` Dialect Passes

[include "LLVMPasses.md"]

## `memref` Dialect Passes

[include "MemRefPasses.md"]

## `quant` Dialect Passes

[include "QuantPasses.md"]

## Reducer Passes

[include "ReducerPasses.md"]

## `scf` Dialect Passes

[include "SCFPasses.md"]

## `shape` Dialect Passes

[include "ShapePasses.md"]

## `sparse_tensor` Dialect Passes

[include "SparseTensorPasses.md"]

## `spv` Dialect Passes

[include "SPIRVPasses.md"]

## `tensor` Dialect Passes

[include "TensorPasses.md"]

## `transform` Dialect Passes

[include "TransformPasses.md"]

## `vector` Dialect Passes

[include "VectorPasses.md"]

## TOSA Dialect Passes

[include "TosaPasses.md"]
